(* $Id: c_select.ml,v 1.6 2008/03/01 19:54:58 deraugla Exp $
 *
 * Rogloglo Toolkit: select widget
 *)

(*
open Xlib;
open Std;
open Rtdecl;
open Util;

type select_local_info = { widlist : list widget };

value (select_local_info, get_select_local_info) =
  dynamo_local_info "select_local_info"
    (ref (None : option select_local_info))
;

value select_raise wid = xRaiseWindow (wid.wid_xd.dpy, wid.win);

value select_desc attr slist =
  let att_val = attribute_values attr in
  {wsize xd =
     let wsh =
       List.fold_left
         (fun csh wdesc ->
            let sh = wdesc.wsize xd in
            let b = sh.sh_border in
            {sh_width = max csh.sh_width (b + sh.sh_width + b);
             sh_height = max csh.sh_height (b + sh.sh_height + b);
             sh_border = csh.sh_border;
             base_width =
               if sh.width_inc == -1 then csh.base_width
               else max csh.base_width (b + sh.base_width + b);
             base_height =
               if sh.height_inc == -1 then csh.base_height
               else max csh.base_height (b + sh.base_height + b);
             width_inc = max sh.width_inc csh.width_inc;
             height_inc = max sh.height_inc csh.height_inc})
         {sh_width = 1; sh_height = 1; sh_border = 0; base_width = 0;
          base_height = 0; width_inc = -1; height_inc = -1}
         slist
     in
     let w = max (opt_val 1 att_val.width_att) wsh.sh_width in
     let h = max (opt_val 1 att_val.height_att) wsh.sh_height in
     let b = max (opt_val 0 att_val.border_att) 0 in
     {sh_width = w; sh_height = h; sh_border = b;
      base_width = if wsh.width_inc == -1 then w else wsh.base_width;
      base_height = if wsh.height_inc == -1 then h else wsh.base_height;
      width_inc = wsh.width_inc; height_inc = wsh.height_inc};
   wcreate xd pwin is_top wdesc x y wsh = (
     let {sh_width = width; sh_height = height; sh_border = border} = wsh in
     let win =
       xCreateSimpleWindow
         (xd.dpy, pwin, x, y, max width 1, max height 1, max border 0,
          xd.black, xd.white)
     in
     let select_list =
       List.rev
         (List.fold_left
            (fun sl wdesc ->
               let {sh_border = b} = wdesc.wsize xd in
               let wid =
                 wdesc.wcreate xd win False wdesc 0 0
                   {sh_width = width - 2 * b; sh_height = height - 2 * b;
                    sh_border = b; base_width = 0; base_height = 0;
                    width_inc = 0; height_inc = 0}
               in
               [wid :: sl])
            [] slist)
     in
     xSelectInput (xd.dpy, win, structureNotifyMask);
     xMapSubwindows (xd.dpy, win);
     xRaiseWindow (xd.dpy, (List.hd select_list).win);
     List.iter (fun wid -> wid.is_mapped := True) select_list;
     let info = select_local_info {widlist = select_list} in
     add_widget att_val win
       (create_widget xd win is_top x y wsh wdesc info select_list)
   );
   wdestroy wid = remove_widget att_val wid.win wid;
   wdispatch wid xev =
     let t = xEvent_type xev in
     if t == configureNotify then (
       let xev = xEvent_xconfigure xev in
       let width = xConfigureEvent_width xev
       and height = xConfigureEvent_height xev
       and border = xConfigureEvent_border_width xev in
       if width <> wid.width || height <> wid.height then
         let xd = wid.wid_xd in
         let li = get_select_local_info wid.info in
         List.iter
           (fun wid ->
              let wsh = wid.wdesc.wsize xd in
              xResizeWindow
                (xd.dpy, wid.win, max (width - 2 * wsh.sh_border) 1,
                 max (height - 2 * wsh.sh_border) 1))
           li.widlist
       else ();
       wid.width := width;
       wid.height := height;
       wid.border := border
     )
     else ();
   wselect _ _ = (); wfreeze wid = (); filler = List.mem FillerAtt attr}
;
*)
